#<profile4xi profile = "31"/>
#<program4xi program = "walk2upgrade4app.py">
#<abstract4xi abstract = "walks through HTML files of spefied directory and its subdirectories upgrading file content as required"/>
#<refer4xi reference = "Studio4Xi"/>
#<note4xi note = "test first with one folder, edit version4xi.py, search text(s) must be unique"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'walk2upgrade4app' ]
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os,sys,string
import time4xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Studio4Xi imports                               
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi
from version4xi import VersionKB4Xi
from version4xi import ROOT4XI 
#"
#/>
# -------------------------------------------------------------------------------------------------
# Multiprocessing4xi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from actor2a4xi import Actor2a4Xi                                                                                  
from actor2b4xi import Actor2b4Xi                                                                                   
from actor2c4xi import Actor2c4Xi
from actor2d4xi import Actor2d4Xi
from actor2e4xi import Actor2e4Xi
from actor2f4xi import Actor2f4Xi
from actor2g4xi import Actor2g4Xi
from actor2h4xi import Actor2h4Xi
from actor2i4xi import Actor2i4Xi
from actor2j4xi import Actor2j4Xi
from actor2k4xi import Actor2k4Xi
from actor2l4xi import Actor2l4Xi
from actor2m4xi import Actor2m4Xi
from actor2n4xi import Actor2n4Xi
from actor2o4xi import Actor2o4Xi
from actor2p4xi import Actor2p4Xi
from actor2q4xi import Actor2q4Xi
from actor2r4xi import Actor2r4Xi
from actor2s4xi import Actor2s4Xi
from actor2t4xi import Actor2t4Xi
from actor2u4xi import Actor2u4Xi
from actor2v4xi import Actor2v4Xi
from actor2w4xi import Actor2w4Xi
from actor2x4xi import Actor2x4Xi
from actor2y4xi import Actor2y4Xi
from actor2z4xi import Actor2z4Xi
from actor2_4xi import Actor2_4Xi

from pickle4xi import pickle4xi                                                                                   
from pickle2a4xi import Pickle2a4Xi
from pickle2b4xi import Pickle2b4Xi
from pickle2c4xi import Pickle2c4Xi
from pickle2d4xi import Pickle2d4Xi
from pickle2e4xi import Pickle2e4Xi
from pickle2f4xi import Pickle2f4Xi
from pickle2g4xi import Pickle2g4Xi
from pickle2h4xi import Pickle2h4Xi
from pickle2i4xi import Pickle2i4Xi
from pickle2j4xi import Pickle2j4Xi
from pickle2k4xi import Pickle2k4Xi
from pickle2l4xi import Pickle2l4Xi
from pickle2m4xi import Pickle2m4Xi
from pickle2n4xi import Pickle2n4Xi
from pickle2o4xi import Pickle2o4Xi
from pickle2p4xi import Pickle2p4Xi
from pickle2q4xi import Pickle2q4Xi
from pickle2r4xi import Pickle2r4Xi
from pickle2s4xi import Pickle2s4Xi
from pickle2t4xi import Pickle2t4Xi
from pickle2u4xi import Pickle2u4Xi
from pickle2v4xi import Pickle2v4Xi
from pickle2w4xi import Pickle2w4Xi
from pickle2x4xi import Pickle2x4Xi
from pickle2y4xi import Pickle2y4Xi
from pickle2z4xi import Pickle2z4Xi
from pickle2_4xi import Pickle2_4Xi 
from pipe4xi import Pipe4Xi   
from print4xi import print4xi
from print4xi import Print4Xi      # from lutiprocessing4xi 
from process4xi import Process4Xi
from queue4xi import Queue4Xi
from time4xi import time4xi

from walk2parse4app import walk2parse4app

from xml_trace_sense4xi import xml_trace_sense4xi                                                                   
from xml_trace_reason4xi import xml_trace_reason4xi
from xml_trace_ace4xi import xml_trace_ace4xi 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/>


# -------------------------------------------------------------------------------------------------
# Globals                            
# -------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global ack2debug
global count2skipped
global count2replaced
global count2total
global file2output

global kb2add
global kb2append
global kb2pass
global kb2replace
global kb2search                             

global key2add
global key2append
global key2pass
global key2replace
global key2search 

global keys2add
global keys2append
global keys2pass
global keys2replace
global keys2search 


global name2create
global path2temp4source  
global path2read4xi                          # path for input source targets
global path2write4xi                         # path for output source targets
global PickleKB4Xi
global profile2fetch                         # extension for files
global t2xi 
global trace_object_count
#"
#"/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = True    # turn on/off 
file2output = None
count2skipped = 0
count2replaced = 0
count2total = 0
 
kb2add      = {}  
kb2append   = {}
kb2pass     = {}  
kb2replace  = {}  
kb2search   = {}  

VersionKB4Xi['input2parse4app'] = VersionKB4Xi['output2upgrade4app'] # to parse output


# ================================================================================================
# KB2APPEND - LINES TO BE WRITTEN BEFORE THE ONE FOUND 
# ================================================================================================

# --------
# RUN9   - NONE
# --------
kb2append    = {}

# --------
# RUN8   - NONE
# --------
# kb2append    = {}

# --------
# RUN7   - NONE
# --------
# kb2append    = {}

# --------
# RUN6   - NONE
# --------
# kb2append    = {}

# --------
# RUN5   - NONE
# --------
# kb2append    = {}


# --------
# RUN4   - NONE
# --------
# kb2append    = {}



# ==============================================================================================
# KB2SEARCH
# ==============================================================================================
# --------
# RUN9 -  EACH STRING TO BE SEARCHED APPEARS ONCE IN ALL INPUT FILES 
# --------
kb2search [1]='<br /><b>[L]</b>'

# --------
# RUN8 -  EACH STRING TO BE SEARCHED APPEARS ONCE IN ALL INPUT FILES 
# --------
# kb2search [1]='<br /><b>[J]</b>'

# --------
# RUN7 -  EACH STRING TO BE SEARCHED APPEARS ONCE IN ALL INPUT FILES 
# --------
# kb2search [1]='<b>&Xi;</b> <b>&raquo;</b> <a href="spec/legal/email_notice.html" target="_blank">email #<sub>1</sub></a>'

# --------
# RUN6 -  EACH STRING TO BE SEARCHED APPEARS ONCE IN ALL INPUT FILES 
# --------
# kb2search [1]='<br /><b>[C]</b>'


# --------
# RUN5 -  EACH STRING TO BE SEARCHED APPEARS ONCE IN ALL INPUT FILES 
# --------
# kb2search [1]='<h3><b>&Psi;</b> Ocean, Desert, Tepui, Environment</h3>'

# --------
# RUN4 -  STRING TO BE SEARCHED APPEARS ONCE IN ALL INPUT FILES 
# --------
# kb2search [1]='<br /><b>[M]</b>'

# --------
# RUN3 -  STRING TO BE SEARCHED APPEARS ONCE IN ALL INPUT FILES 
# --------
# kb2search [1]='<h3><b>&Psi;</b> Ocean, Desert, Tepui, Environment</h3>'

# --------
# RUN2 -  STRING TO BE SEARCHED APPEARS ONCE IN ALL INPUT FILES 
# --------
# kb2search [1]='<h3><b>&Phi;</b> Deep Technology</h3>'

# --------
# RUN1 -  STRING TO BE SEARCHED APPEARS ONCE IN ALL INPUT FILES 
# --------
# kb2search [1]='<h3><b>&Psi;</b> Ocean, Desert, Tepui, Environment</h3>'



# ==============================================================================================
# KB2REPLACE
# ==============================================================================================
# --------
# RUN9 -  # only one to replace in input files
# --------
key2replace = 1   
kb2replace [key2replace] = {
0: '<br /><b>[L]</b>' + '\n',
1: '  </td>' + '\n',
2: '</tr>' + '\n',
3: '<!-- =============================================================================================================== -->' + '\n',
4: '<tr>' + '\n',
5: '  <td>' + '\n',
6: '     <b>&Delta;</b> loihi' + '\n',
7: '     <b>&raquo;</b><a href="https://www.loihi.app" target="_blank">.app</a>' + '\n',
8: '     <b>&raquo;</b><a href="https://www.loihi.dev" target="_blank">.dev</a>' + '\n',
9: '  </td>' + '\n',
10: '</tr>' + '\n'
}

# --------
# RUN8 -  # only one to replace in input files
# --------
# key2replace = 1   
# kb2replace [key2replace] = {
# 0: '<br /><b>[J]</b>' + '\n',
# 1: '  </td>' + '\n',
# 2: '</tr>' + '\n',
# 3: '<!-- =============================================================================================================== -->' + '\n',
# 4: '<tr>' + '\n',
# 5: '  <td>' + '\n',
# 6: '     <b>&Delta;</b> jetport' + '\n',
# 7: '     <b>&raquo;</b><a href="https://www.jetport.app" target="_blank">.app</a>' + '\n',
# 8: '     <b>&raquo;</b><a href="https://www.jetport.dev" target="_blank">.dev</a>' + '\n',
# 9: '  </td>' + '\n',
# 10: '</tr>' + '\n'
# }

# --------
# RUN7 -  # only one to replace in input files
# --------
# key2replace = 1                      
# kb2replace [key2replace] = {
# 0: '<b>&Xi;</b> <b>&raquo;</b> <a href="spec/legal/email_notice.html" target="_blank">email #<sub>1</sub></a>' + '\n',
# 1: '    <div class="set2email4xi"><img src="spec/images/jpg/xi_icons_cbo.jpg" alt="Chief BIO (CBO) of DragonXi powered by Artificial Intelligence (AI)"  height="100" width="73" /></div>' + '\n',
# 2: '    @yourdragonxi.com' + '\n',
# 3: '<br /> <b>&Delta;</b> caribbeansea' + '\n',
# 4: '       <b>&raquo;</b><a href="https://caribbeansea.app/" target="_blank">.app</a>' + '\n',
# 5: '       <b>&raquo;</b><a href="https://caribbeansea.dev/" target="_blank">.dev</a>' + '\n',
# 6: '\n',
# 7: '\n',
# 8: '\n',
# 9: '\n',
# 10:'\n'
# }

# --------
# RUN6 -  # only one to replace in input files
# --------
# key2replace = 1                      
# kb2replace [key2replace] = {
# 0: '   <br /><b>[C]</b>' + '\n',
# 1: '  </td>' + '\n',
# 2: '</tr>' + '\n',
# 3: '<!-- =============================================================================================================== -->' + '\n',
# 4: '<tr>' + '\n',
# 5: ' <td>' + '\n',
# 6: '     <b>&Delta;</b> caribbeansea' + '\n',
# 7: '     <b>&raquo;</b><a href="https://caribbeansea.app/" target="_blank">.app</a>' + '\n',
# 8: '     <b>&raquo;</b><a href="https://caribbeansea.dev/" target="_blank">.dev</a>' + '\n',
# 9: ' </td>' + '\n',
# 10: '</tr>' + '\n'
# }

# --------
# RUN5 -  # only one to replace in input files
# --------
# key2replace = 1                      
# kb2replace [key2replace] = {
# 0: '<h3><b>&Psi;</b> Ocean, Desert, Tepui, Environment</h3>' + '\n',
# 1: '    <div class="set2sphere4xi"><img src="spec/images/jpg/xiball4.jpg" alt="Sphere of DragonXi powered by Artificial Intelligence (AI)"  height="150" width="150" /></div>' + '\n',
# 2: ' </td>' + '\n',
# 3: '</tr>' + '\n',
# 4: '<tr>' + '\n',
# 5: ' <td>' + '\n',
# 6: '       <b>&Delta;</b> caribbeansea' + '\n',
# 7: '       <b>&raquo;</b><a href="https://www.caribbeansea.app" target="_blank">app</a>' + '\n',
# 8: '       <b>&raquo;</b><a href="https://www.caribbeansea.dev" target="_blank">dev</a>' + '\n',
# 9: ' </td>' + '\n',
# 10: '</tr>' + '\n'
# }





# --------
# RUN4 -  # only one to replace in input files
# --------
# key2replace = 1                      
# kb2replace [key2replace] = {
# 0: '   <br /><b>[M]</b>' + '\n',
# 1: '  </td>' + '\n',
# 2: '</tr>' + '\n',
# 3: '<!-- =============================================================================================================== -->' + '\n',
# 4: '<tr>' + '\n',
# 5: ' <td>' + '\n',
# 6: '     <b>&Delta;</b> machineprogramming' + '\n',
# 7: '     <b>&raquo;</b><a href="https://machineprogramming.app/" target="_blank">.app</a>' + '\n',
# 8: '     <b>&raquo;</b><a href="https://machineprogramming.dev/" target="_blank">.dev</a>' + '\n',
# 9: ' </td>' + '\n',
# 10: '</tr>' + '\n'
# }

# --------
# RUN3 -  # only one to replace in input files
# --------
# key2replace = 1                      
# kb2replace [key2replace] = {
# 0: '       <h3><b>&Psi;</b> Ocean, Desert, Tepui, Environment</h3>' + '\n',
# 1: '       <div class="set2sphere4xi"><img src="spec/images/jpg/xiball4.jpg" alt="Sphere of DragonXi powered by Artificial Intelligence (AI)"  height="150" width="150" /></div>' + '\n',
# 2: ' </td>' + '\n',
# 3: '</tr>' + '\n',
# 4: '<tr>' + '\n',
# 5: ' <td>' + '\n',
# 6: '       <b>&Delta;</b> atlanticocean' + '\n',
# 7: '       <b>&raquo;</b><a href="https://www.atlanticocean.app" target="_blank">app</a>' + '\n',
# 8: '       <b>&raquo;</b><a href="https://www.atlanticocean.dev" target="_blank">dev</a>' + '\n',
# 9: ' </td>' + '\n',
# 10: '</tr>' + '\n',
# 11: '<tr>' + '\n',
# 12: ' <td>' + '\n',
# 13: '       <b>&Delta;</b> pacificocean' + '\n', 
# 14: '       <b>&raquo;</b><a href="https://www.pacificocean.app" target="_blank">app</a>' + '\n',
# 15: '       <b>&raquo;</b><a href="https://www.pacificocean.dev" target="_blank">dev</a>' + '\n',
# 16: ' </td>' + '\n',
# 17: '</tr>' + '\n',
# 18: '<tr>' + '\n'
# }

# --------
# RUN2 -  # only one to replace in input files
# --------
# key2replace = 1                      
# kb2replace [key2replace] = {
# 0: '       <h3><b>&Psi;</b> Space</h3>' + '\n',
# 1: '       <div class="set2sphere4xi"><img src="spec/images/jpg/xiball3.jpg" alt="Sphere of DragonXi powered by Artificial Intelligence (AI)"  height="150" width="150" /></div>' + '\n',
# 2: ' </td>' + '\n',
# 3: '</tr>' + '\n',
# 4: '<!-- =============================================================================================================== -->' + '\n',
# 5: '<tr>' + '\n',
# 6: '  <td>' + '\n',
# 7: '     <b>&Delta;</b> aeronautics' + '\n',
# 8: '     <b>&raquo;</b><a href="https://aeronautics.app/" target="_blank">app</a>' + '\n',
# 9: '     <b>&raquo;</b><a href="https://aeronautics.dev/" target="_blank">dev</a>' + '\n',
# 10: '  </td>' + '\n',
# 11: '</tr>' + '\n',
# 12: '' + '\n',
# 13: '<!-- =============================================================================================================== -->' + '\n',
# 14: '<tr>' + '\n',
# 15: '  <td>' + '\n',
# 16: '     <b>&Delta;</b> beyondspace' + '\n',
# 17: '     <b>&raquo;</b><a href="https://beyondspace.app/" target="_blank">.app</a>' + '\n',
# 18: '     <b>&raquo;</b><a href="https://beyondspace.dev/" target="_blank">.dev</a>' + '\n',
# 19: '  </td>' + '\n',
# 20: '</tr>' + '\n',
# 21: '' + '\n',
# 22: '<!-- =============================================================================================================== -->' + '\n',
# 23: '<tr>' + '\n',
# 24: '  <td>' + '\n',
# 25: '     <b>&Delta;</b> beyonduniverse' + '\n',
# 26: '     <b>&raquo;</b><a href="https://beyonduniverse.app/" target="_blank">.app</a>' + '\n',
# 27: '     <b>&raquo;</b><a href="https://beyonduniverse.dev/" target="_blank">.dev</a>' + '\n',
# 28: '  </td>' + '\n',
# 29: '</tr>' + '\n',
# 30: '' + '\n',
# 31: '<!-- =============================================================================================================== -->' + '\n',
# 32: '<tr>' + '\n',
# 33: '  <td>' + '\n',
# 34: '     <b>&Delta;</b> cryogenics' + '\n',
# 35: '     <b>&raquo;</b><a href="https://cryogenics.app/" target="_blank">.app</a>' + '\n',
# 36: '    <b>&raquo;</b><a href="https://cryogenics.dev/" target="_blank">.dev</a>' + '\n',
# 37: '  </td>' + '\n',
# 38: '</tr>' + '\n',
# 39: '' + '\n',
# 40: '<!-- =============================================================================================================== -->' + '\n',
# 41: '<tr>' + '\n',
# 42: '  <td>' + '\n',
# 43: '     <b>&Delta;</b> missionprofile' + '\n',
# 44: '     <b>&raquo;</b><a href="https://www.missionprofile.app" target="_blank">.app</a>' + '\n',
# 45: '  </td>' + '\n',
# 46: '</tr>' + '\n',
# 47: '' + '\n',
# 48: '<!-- =============================================================================================================== -->' + '\n',
# 49: '<tr>' + '\n',
# 50: '  <td>' + '\n',
# 51: '     <b>&Delta;</b> spacescience' + '\n',
# 52: '     <b>&raquo;</b><a href="https://spacescience.app/" target="_blank">.app</a>' + '\n',
# 53: '     <b>&raquo;</b><a href="https://spacescience.dev/" target="_blank">.dev</a>' + '\n',
# 54: '  </td>' + '\n',
# 55: '</tr>' + '\n',
# 56: '' + '\n',
# 57: '<!-- =============================================================================================================== -->' + '\n',
# 58: '<tr>' + '\n',
# 59: '  <td>' + '\n',
# 60: '     <b>&Delta;</b> waterexploration' + '\n',
# 61: '     <b>&raquo;</b><a href="https://waterexploration.app/" target="_blank">.app</a>' + '\n',
# 62: '  </td>' + '\n',
# 63: '</tr>' + '\n',
# 64: '' + '\n',
# 65: '<!-- =============================================================================================================== -->' + '\n',
# 66: '<tr>' + '\n',
# 67: '  <td>' + '\n',
# 68: '     <b>&Delta;</b> xenobiotic' + '\n',
# 69: '     <b>&raquo;</b><a href="https://www.xenobiotic.app" target="_blank">.app</a>' + '\n',
# 70: '     <b>&raquo;</b><a href="https://www.xenobiotic.dev" target="_blank">.dev</a>' + '\n',
# 71: '  </td>' + '\n',
# 72: '</tr>' + '\n'
# }

# --------
# RUN1 -  # only one to replace in input files
# --------
# key2replace = 1                      
# kb2replace [key2replace] = {
# 0: '       <h3><b>&Psi;</b> Ocean, Desert, Tepui, Environment</h3>' + '\n',
# 1: '       <div class="set2sphere4xi"><img src="spec/images/jpg/xiball4.jpg" alt="Sphere of DragonXi powered by Artificial Intelligence (AI)"  height="150" width="150" /></div>' + '\n',
# 2: ' </td>' + '\n',
# 3: '</tr>' + '\n',
# 4: '' + '\n',
# 5: '' + '\n',
# 6: '<tr>' + '\n',
# 7: ' <td>' + '\n',
# 8: '       <b>&Delta;</b> atlanticocean' + '\n',
# 9: '       <b>&raquo;</b><a href="https://www.atlanticocean.app" target="_blank">app</a>' + '\n',
# 10: '       <b>&raquo;</b><a href="https://www.atlanticocean.dev" target="_blank">dev</a>' + '\n',
# 11: ' </td>' + '\n',
# 12: '</tr>' + '\n',
# 13: '<tr>' + '\n',
# 14: ' <td>' + '\n',
# 15: '       <b>&Delta;</b> pacificocean ' + '\n',
# 16: '       <b>&raquo;</b><a href="https://www.pacificocean.app" target="_blank">app</a>' + '\n',
# 17: '       <b>&raquo;</b><a href="https://www.pacificocean.dev" target="_blank">dev</a>' + '\n',
# 18: ' </td>' + '\n',
# 19: '</tr>' + '\n'
# }

# ==============================================================================================
# KB2ADD - set according to the number of lines to be added from kb2replace after the replaced one
# note: key2add goes up to max2range - 1; min key2add = 2 
#       either use walk2replace4app.py just to replace or add an empty line
# ==============================================================================================
# --------
# RUN9
# --------
max2range = 11  

# --------
# RUN8
# --------
# max2range = 11  

# --------
# RUN7
# --------
# max2range = 11  

# --------
# RUN6
# --------
# max2range = 11  

# --------
# RUN5
# --------
# max2range = 11  

# --------
# RUN4
# --------
# max2range = 11  

# --------
# RUN3
# --------
# max2range = 19  

# --------
# RUN2
# --------
# max2range = 73   

# --------
# RUN1
# --------
# max2range = 20                         

for key2add in range(1, max2range):
    kb2add [key2add] = key2add


# ==============================================================================================
# KB2PASS - set according to the number of lines to be passed based 
#           after all lines from kb2replace have been written 
# ==============================================================================================
# --------
# RUN9
# --------
max2pass = 3 

# --------
# RUN8
# --------
# max2pass = 3 

# --------
# RUN7
# --------
# max2pass = 12 

# --------
# RUN6
# --------
# max2pass = 12 

# --------
# RUN5
# --------
# max2pass = 12 

# --------
# RUN4
# --------
# max2pass = 11 

# --------
# RUN3
# --------
# max2pass = 21 

# --------
# RUN2
# --------
# max2pass = 79 

# --------
# RUN1
# --------
# max2pass = 5 

for key2pass in range(1, max2pass): # key2pass goes up to max2pass - 1
    kb2pass [key2pass] = key2pass
    
    
# -------------------------------------------------------------------------------------------------
#
# -------------------------------------------------------------------------------------------------
keys2add     = kb2add.keys()        
keys2append  = kb2append.keys()
keys2pass    = kb2pass.keys()
keys2search  = kb2search.keys()
keys2replace = kb2replace.keys()

    
# -------------------------------------------------------------------------------------------------
#
# -------------------------------------------------------------------------------------------------
path2write4xi = None

path2read4xi  = VersionKB4Xi['input2upgrade4app']   # defines input folder to be walked with all its subfolders
path2write4xi = VersionKB4Xi['output2upgrade4app']  # defines output folder for savings 
    
# -------------------------------------------------------------------------------------------------
#
PickleKB4Xi = {
       'a': Pickle2a4Xi,
       'b': Pickle2b4Xi,
       'c': Pickle2c4Xi,
       'd': Pickle2d4Xi,
       'e': Pickle2e4Xi,
       'f': Pickle2f4Xi,
       'g': Pickle2g4Xi,
       'h': Pickle2h4Xi,
       'i': Pickle2i4Xi,
       'j': Pickle2j4Xi,
       'k': Pickle2k4Xi,
       'l': Pickle2l4Xi,
       'm': Pickle2m4Xi,
       'n': Pickle2n4Xi,
       'o': Pickle2o4Xi,
       'p': Pickle2p4Xi,
       'q': Pickle2q4Xi,
       'r': Pickle2r4Xi,
       's': Pickle2s4Xi,
       't': Pickle2t4Xi,
       'u': Pickle2u4Xi,
       'v': Pickle2v4Xi,
       'w': Pickle2w4Xi,
       'x': Pickle2x4Xi,
       'y': Pickle2y4Xi,
       'z': Pickle2z4Xi,
       '_': Pickle2_4Xi} 

#"
#"/>

# -------------------------------------------------------------------------------------------------
#<define4xi definition = "
profile2fetch = '.html'                      # object types to be fetched
                                             # '.txt'= text '.py'=Python, '.cpp'=C++, '.hpp'=headers, '.c'=C, 
                                             # '.html', 'xml'

#"
#/>


# ----------------------------------------------------------------------------------------------------------
#<function4xi function = "set2trace4replace" usage = "setting trace using definitions in pickle4xi functions !
#">                      
# ----------------------------------------------------------------------------------------------------------    
def set2trace4replace():
    global ack2debug
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    if ack2debug is True:
        print("(Step 1A/33) OF SET2TRACE4REPLACE - STARTING SETTING TRACE BASED ON TRACE SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
        print("(Step 1B/33) OF SET2TRACE4REPLACE - USING T2XI: ", t2xi)
        # <print4xi.Print4Xi object at 0x0000000003715080>    
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('=' *33)
        # print("STARTING LETTER : ", key2pickledb)
        # print('=' *33)
   
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("STARTING DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
        # 
        keys2dictionary = sorted(dictionary2pickle.keys())
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
            # -------------------------------------------------------------------------------------     
            # print('~' *33)        
            object2pickle = key2dictionary        
            # print("STARTING OBJECT: ", object2pickle)
            # print('~' *33)         
            # pickle4xi(object2pickle)
            # print('~' *33)                  
            # print("PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            # ---------------------------------------------------------------------------------    
            # Mark those with NACK4XI to be traced !
            # ---------------------------------------------------------------------------------     
            if dictionary2pickle[key2dictionary] == 'NACK4XI':
                set_param2xi = True     
                key_param = object2pickle     
                t2xi.set_print_permission(key_param, set_param2xi)
                # print("(Step 2A/33) OF SET2TRACE4REPLACE - MARKED TO BE TRACED OBJECT: ", object2pickle)                                
                # APU2Buffer4Xi; APU2CommandQueue4Xi ... finish2commandqueue4bpu; finish2commandqueue4apu ...
            else:
                pass  
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('~' *33)        
        # print("COMPLETED  DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print('=' *33)
    # print("COMPLETED LETTER : ", key2pickledb)
    # print('=' *33)
    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------
    if ack2debug is True:
        print('=' *33)
        print("(Step 33/33) OF SET2TRACE4REPLACE - COMPLETED SETTING TRACE BASED ON NACK4XI/ACK4XI SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
        print('=' *33)
#</function4xi> 

       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "deny2trace4replace" usage = "
#   deny trace using pickle4xi functions !
#">                      
# -------------------------------------------------------------------------------------------------    
def deny2trace4replace():
    global ack2debug
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    if ack2debug is True:
        print("(Step 01A/33) of DENY2TRACE4REPLACE: STARTING DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
        print("(Step 01B/33) OF DENY2TRACE4REPLACE - USING T2XI: ", t2xi)
        # <print4xi.Print4Xi object at 0x0000000003715080>
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02A/33) OF DENY2TRACE4REPLACE - STARTING LETTER : ", key2pickledb)
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("(Step 02B/33) OF DENY2TRACE4REPLACE - STARTING DICTIONARY: ", dictionary2pickle)
        keys2dictionary = sorted(dictionary2pickle.keys())
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
   
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
   
            object2pickle = key2dictionary        
            # print("(Step 02C/33) OF DENY2TRACE4REPLACE - STARTING OBJECT: ", object2pickle)
            # pickle4xi(object2pickle)        
            # print("STEP: PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            
            # ---------------------------------------------------------------------------------    
            # ACK4XI = tested .i.e. NOT to be traced! 
            # ---------------------------------------------------------------------------------     
            set_param2xi = 'ACK4XI'     
            key_param = object2pickle     
            t2xi.set_print_permission(key_param, set_param2xi)
            # print("(Step 02D/33) OF DENY2TRACE4REPLACE - MARKED TESTED AND NOT to be traced: ", object2pickle)
            
            dictionary2pickle[key2dictionary] = 'ACK4XI' 
                    
        
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
            # print('~' *33)              
            # print("(Step 02Z/33) OF DENY2TRACE4REPLACE *** FAILED - ERROR IN PICKLING OBJECT - NOT TO BE TRACED: ", object2pickle)
            # print('~' *33) 
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02E/33) OF DENY2TRACE4REPLACE - COMPLETED  DICTIONARY: ", dictionary2pickle)
        # 
        
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print("(Step 02F/33) OF DENY2TRACE4REPLACE - COMPLETED LETTER : ", key2pickledb)
    # _, a ... z            
    if ack2debug is True:
        print("(Step 033/33) OF SET2TRACE4REPLACE - COMPLETED DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "tailor2trace4xi" usage = "
#   tailors trace 
#">                      
# -------------------------------------------------------------------------------------------------    
def tailor2trace4xi():
    global ack2debug
    global trace_object_count
    global PickleKB4Xi 
    global t2xi
 
    if ack2debug is True:
        print("(Step 001A/33) OF TAILOR2TRACE4REPLACE - USING T2XI: ", t2xi)
        # <print4xi.Print4Xi object at 0x0000000003715080> 
                         
    # ---------------------------------------------------------------------------------------------
    # Settings to tailor trace
    # ---------------------------------------------------------------------------------------------
    #<set4xi setting = "
    KB4Tailoring = {
         # 'Pipe4Xi': 'NACK4TRACE',
         # 'Queue4Xi': 'NACK4TRACE',         
         # 'Process4Xi': 'NACK4TRACE',
         'walk2upgrade4app': 'NACK4TRACE' # turns on/off
        }                             
                
    default3trace = 'NACK4TRACE' # we do NOT want trace if object is not found! 
    #"/>
    
    # ---------------------------------------------------------------------------------------------
    # PROCESS KB4Tailoring
    # ---------------------------------------------------------------------------------------------
    keys2tailor = sorted(KB4Tailoring.keys())
    for key2tailor in keys2tailor:
        # ---------------------------------------------------------------------------------    
        # NACK4XI = NOT TESTED .I.E. TO BE TRACED! 
        # ---------------------------------------------------------------------------------     
        set_param2xi = 'NACK4XI'     
        key_param = key2tailor    
        t2xi.set_print_permission(key_param, set_param2xi)
        if ack2debug is True:
            print("(Step 002A/33) OF TAILOR_TRACE4XI - MARKED TO BE TESTED: ", key2tailor)
            # Pipe4Xi, Process4Xi, Queue4Xi, walk2upgrade4app

    # -----------------------------------------------------------------------------------------    
    # EOF KEYS
    # -----------------------------------------------------------------------------------------     
    if ack2debug is True:
        print("(Step 0033/33) OF TAILOR_TRACE4XI - COMPLETED  TAILORING: ", time4xi())
        #

    
     
#</function4xi>             
    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "print-trace4xi" usage = "
# print XML trace
#"> 
# -------------------------------------------------------------------------------------------------    
def print_trace4xi(t2xi):
    
    class2print  = "walk2upgrade4app"
    method2print = "walk2upgrade4app" 
        
    message2print = "{passed" + "; t2xi-passed-to-print-trace4xi: " + str(t2xi) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)   
    #    

    # -------------------------------------------------------------------------------------------------
    # SENSE                        
    # -------------------------------------------------------------------------------------------------  
    context2sense = {
     'file_path4xi': '..//..//..//..//web//xml//sense-walk2upgrade4app.xml',
     'name_space4xi': '   xmlns="https://www.yourdragonxi.org/sw4xi/python33/xml/walk2upgrade4app.owl#"\n',
     'xml_base4xi': '   xml:base="https://www.yourdragonxi.org/sw4xi/python33/xml/walk2upgrade4app.owl#"\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Sensing ofStudio4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Classes, methods and messages with context.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="yourDragon4Xi#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Sensing walk2upgrade4app.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="sensed#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">walk2upgrade4app sensed.</rdfs:comment>\n',
     'debug4xi': True}
      
    xml_trace_sense4xi(t2xi, context2sense)

    # -------------------------------------------------------------------------------------------------
    # REASON                         
    # -------------------------------------------------------------------------------------------------  
        
    context2reason = {
     'file_path4xi': '..//..//..//..//web//xml//reason-walk2upgrade4app.xml',
     'name_space4xi': '   xmlns="https://www.yourdragonxi.org/sw4xi/python33/xml/walk2upgrade4app.owl#"\n',
     'xml_base4xi': '   xml:base="https://www.yourdragonxi.org/sw4xi/python33/xml/walk2upgrade4app.owl#"\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Reasoning of Studio4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Operations</rdfs:comment>\n',
     'operation_comment4xi': '      <rdfs:comment xml:lang="en">Operations for walk2upgrade4app.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="reasoned#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Operations with context.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="reason#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">reason</rdfs:comment>\n',
     'debug4xi': True}
       
    xml_trace_reason4xi(t2xi, context2reason)

    # -------------------------------------------------------------------------------------------------
    # ACE                         
    # -------------------------------------------------------------------------------------------------  
       
    context2ace = {
     'file_path4xi': '..//..//..//..//web//xml//ace-walk2upgrade4app.xml',
     'name_space4xi': '   xmlns="https://www.yourdragonxi.org/sw4xi/python33/xml/walk2upgrade4app.owl#"\n',
     'xml_base4xi': '   xml:base="https://www.yourdragonxi.org/sw4xi/python33/xml/walk2upgrade4app.owl#"\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Acing of Studio4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for walk2upgrade4app.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="ACE4Xi#0000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values of walk2upgrade4app.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="ace#0000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">000000</rdfs:comment>\n',
     'debug4xi': True}   
    
    xml_trace_ace4xi(t2xi, context2ace)


    # -------------------------------------------------------------------------------------------------
    # end of print_trace4xi                        
    # -------------------------------------------------------------------------------------------------  
#</function4xi>
       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "walk2upgrade4app" usage = "
#   replaces defined targets from dragon4xi folders
#"> 
# -------------------------------------------------------------------------------------------------
def walk2upgrade4app(target2explore):
    global ack2debug
    global count2skipped
    global count2replaced
    global count2total
    
    global kb2add
    global kb2append
    global kb2pass
    global kb2replace
    global kb2search                             

    global key2add
    global key2append
    global key2pass
    global key2replace
    global key2search 

    global keys2add
    global keys2append
    global keys2pass
    global keys2replace
    global keys2search 
     
    global name2create   
    global path2read4xi                            # path for input source targets
    global path2write4xi                           # path for output source targets
    global profile2fetch                           # extension for files

    global t2xi
    global trace_object_count    
    
    class2print  = "walk2upgrade4app"
    method2print = "walk2upgrade4app" 
 
    message2print = "{(Step 0A/33) using" + "; t2xi-using-by-walk2upgrade4app: " + str(t2xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)         
    # <print4xi.Print4Xi object at 0x0000000003715080>
    
    message2print = "{(Step 1/8) got" + "; target2explore-got-by-walk2upgrade4app: " + str(target2explore)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
    # G://temp//job2studio4xi//in//one2do4app//app2ace4yo_app\index.html 
               
    # ---------------------------------------------------------------------------------------------
    # SPLIT TARGET NAME WITH PATH AND EXTENSION TO TWO PIECES
    # ---------------------------------------------------------------------------------------------    
    name2target=os.path.splitext(target2explore)
    
    path2input = None    
    if name2target[1] == profile2fetch:
        # html
                  
        # -----------------------------------------------------------------------------------------
        # (Step 1/33) OF WALK2UPGRADE4APP - TARGET ACCORDING TO PROFILE
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 1A/33) analyzing" + "; target2explore-analyzing-by-walk2upgrade4app: " + str(target2explore) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)      
        # G://temp//job2studio4xi//in//one2do4app//app2ace4yo_app\index.html
        
        # -----------------------------------------------------------------------------------------
        # (Step 2/33) OF WALK2UPGRADE4APP - INPUT FILE PATH 
        # -----------------------------------------------------------------------------------------
        path2input = name2target[0] + profile2fetch 
        message2print = "{(Step 2A/33) set" + "; path2input-set-by-walk2upgrade4app to: " + str(path2input)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
        # G://temp//job2studio4xi//in//one2do4app//encrypted_dragonxi\index.html

        # -----------------------------------------------------------------------------------------
        # (Step 3/33) OF WALK2UPGRADE4APP - OPEN INPUT FILE
        # -----------------------------------------------------------------------------------------
        file2input = open(path2input,'r')
        message2print = "{(Step 3A/33) opened" + "; file2input-opened-by-walk2upgrade4app: " + str(file2input) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)     
        # <_io.TextIOWrapper name='G://temp//job2studio4xi//in//one2do4app//encrypted_dragonxi\\index.html' mode='r' encoding='cp1252'>
         
        # -----------------------------------------------------------------------------------------
        # (Step 3/33) OF WALK2UPGRADE4APP - OUTPUT FILE NAME 
        # -----------------------------------------------------------------------------------------
        string2skip = '/'
        name2create = path2input
        max2try = 33
        count2try = 0
        while 1:
            index2skip = str.find(name2create,string2skip)
            count2try = count2try + 1
            if (index2skip == -1) or (count2try > max2try):
                break
            else:
                name2create = name2create[index2skip+1:]
                
        message2print = "{(Step 3B/33) set" + "; name2create to: " + str(name2create) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # encrypted_dragonxi\index.html
                
        # -----------------------------------------------------------------------------------------
        # (Step 4/33) OF WALK2UPGRADE4APP - OPEN OUTPUT FILE
        # -----------------------------------------------------------------------------------------
        path2output = path2write4xi + name2create
        
        message2print = "{(Step 4A/33) set" + "; path2output-set-by-walk2upgrade4app to: " + str(path2output) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)     
        # G://temp//job2studio4xi//out//one2ftp4app//app2ace4yo_app\index.html        
        
        file2output = open(path2output,'w') 
        message2print = "{(Step 4B/33) opened" + "; file2output-opened-by-walk2upgrade4app: " + str(file2output) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)     
        # G://temp//job2studio4xi//out//one2ftp4app//app2ace4yo_app\\index.html 

        while 1:
            # -------------------------------------------------------------------------------------
            # (Step 5/33) OF WALK2UPGRADE4APP - PROCESS FILE
            # -------------------------------------------------------------------------------------             
            line2process = file2input.readline()  
            if not line2process:
                # ---------------------------------------------------------------------------------
                # (Step 5/33) OF WALK2UPGRADE4APP - ALL LINES READ, FINISH
                # ---------------------------------------------------------------------------------             
                break                                               
            else:
                # ---------------------------------------------------------------------------------
                # (Step 7/33) OF WALK2UPGRADE4APP - EXAMINE AND IF NEEDED, PROCESS LINE 
                # ---------------------------------------------------------------------------------
                line2write = line2process
                first2tell = True
                ack2replace = False
                # 
                for key2search in keys2search:
                    # -----------------------------------------------------------------------------
                    # check all strings to be replaced
                    # ----------------------------------------------------------------------------- 
                    string2search = kb2search[key2search]
                    len2search = len(string2search)
                    
                    string2update = kb2replace[key2search] [0]
                    len2update = len(string2update)
                    
                    difference2len = len2update - len2search
                        
                    index2replace = str.find(line2write,string2search)
                    if (index2replace == -1):
                        pass
                    else:
                        ack2replace = True
                        if first2tell is True: 
                            message2print = "{(Step 7A/33) got" + "; line2process-got-by-walk2upgrade4app: " + str(line2process) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # <h3><b>&Psi;</b> Ocean, Desert, Tepui, Environment</h3>
                            key2replace = key2search
                            first2tell = False
                              
                        message2print = "{(Step 7B/33) got" + "; string2search-got-by-walk2upgrade4app: " + str(string2search) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        # h3><b>&Psi;</b> Ocean, Desert, Tepui, Environment</h3>
                        
                        message2print = "{(Step 7C/33) got" + "; string2update-got-by-walk2upgrade4app: " + str(string2update) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        # <h3><b>&Psi;</b> Ocean, Desert, Tepui, Environment</h3>
                        
                        message2print = "{(Step 7D/33) set" + "; index2replace-set-by-walk2upgrade4app to: " + str(index2replace) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        # 7
                        
                        message2print = "{(Step 7E/33) got" + "; begin2write-got-by-walk2upgrade4app: " + str(line2write[0:index2replace]) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        #
                        
                                               
                        begin2write = line2write[0:index2replace] + string2update
                        
                        message2print = "{(Step 7F/33) set" + "; begin2write-set-by-walk2upgrade4app to: " + str(begin2write) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        # <h3><b>&Psi;</b> Ocean, Desert, Tepui, Environment</h3>
                        
                        
                        index2next = index2replace + len2search                      
                        message2print = "{(Step 7G/33) set" + "; index2next-set-by-walk2upgrade4app to: " + str(index2next) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        # 62 
                        
                        line2write = begin2write + line2write[index2next:]
                        
                        message2print = "{(Step 7H/33) set" + "; line2write-set-by-walk2upgrade4app to: " + str(line2write) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        # <h3><b>&Psi;</b> Ocean, Desert, Tepui, Environment</h3>
                          
                # ---------------------------------------------------------------------------------
                # (Step 29/33) OF WALK2UPGRADE4APP - WRITE PROCESSED LINE 
                # ---------------------------------------------------------------------------------                           
                if ack2replace is True:
                    message2print = "{(Step 7I/33) got" + "; line2write-got-by-walk2upgrade4app: " + str(line2write) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                    # <h3><b>&Psi;</b> Ocean, Desert, Tepui, Environment</h3>

                    # ---------------------------------------------------------------------------------
                    # WRITE FIRST LINES FROM KB2APPEND (IF ANY) 
                    # ---------------------------------------------------------------------------------
                    for key2append in keys2append:
                        if key2append > 0:
                            line2append = kb2append[key2append]
                            message2print = "{(Step 7J/33) got" + "; line2append-got-by-walk2upgrade4app: " + str(line2append) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # 
                            file2output.write(append)                    

                    # ---------------------------------------------------------------------------------
                    # WRITE THE LINE REPLACED (MAY HAVE THE SAME CONTENT) 
                    # ---------------------------------------------------------------------------------                                        
                    file2output.write(line2write)
                    message2print = "{(Step 7K/33) wrote" + "; line2write-wrote-by-walk2upgrade4app: " + str(line2write) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                    # <h3><b>&Psi;</b> Ocean, Desert, Tepui, Environment</h3>
                            
                    # ---------------------------------------------------------------------------------
                    # WRITE LINES FROM kb2replace USING key2add  JATKAA
                    # ---------------------------------------------------------------------------------    
                    message2print = "{(Step 7L/33) got" + "; key2replace-got-by-walk2upgrade4app: " + str(key2replace) + "; time: " + time4xi() + "}"
                    # 1
                    for key2add in keys2add:
                        if key2add > 0:
                            line2write = kb2replace [key2replace] [key2add]
                            message2print = "{(Step 7N/33) got" + "; key2add-got-by-walk2upgrade4app: " + str(key2add) + "; time: " + time4xi() + "}"
                            # 1 ...
                            
                            print4xi(class2print, method2print, message2print)
                            message2print = "{(Step 7M/33) got" + "; line2write-got-by-walk2upgrade4app: " + str(line2write) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # <div class="set2sphere4xi"><img src="spec/images/jpg/xiball4.jpg" alt="Sphere of DragonXi powered by Artificial Intelligence (AI)"  height="150" width="150" /></div>
                            # </td>
                            # </tr>
                            # ...
                            # <b>&raquo;</b><a href="https://www.pacificocean.dev" target="_blank">dev</a>
                            # </td>
                            # </tr>
                            file2output.write(line2write)
                        else:
                            # 
                            pass    
                    # ---------------------------------------------------------------------------------
                    # READ THE LINES FROM INPUT FILE WITHOUT PROCESSING THEM JATKAA
                    # ---------------------------------------------------------------------------------        
                    for key2pass in keys2pass: 
                        if not line2process:
                            break    
                        line2process = file2input.readline()
                        message2print = "{(Step 7O/33) got" + "; line2process-got-by-walk2upgrade4app: " + str(line2process) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        #        <div class="set2sphere4xi"><img src="spec/images/jpg/xiball4.jpg" alt="Sphere of DragonXi powered by Artificial Intelligence (AI)"  height="150" width="150" /></div>
                        # </td>
                        # </tr>
                            
                    
                else:
                    file2output.write(line2process)
            
        # -----------------------------------------------------------------------------------------
        # (Step 31/33) OF WALK2UPGRADE4APP - CLOSE INPUT
        # -----------------------------------------------------------------------------------------            
        file2input.close()
        message2print = "{(Step 31A/33) closed" + "; file2input-closed-by-walk2upgrade4app: " + str(file2input) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)           
        # G://temp//job2studio4xi//in//one2do4app//app2ace4yo_app\\index.html' mode='r' encoding='cp1252'>
            
                        
        # -----------------------------------------------------------------------------------------
        # (Step 32/33) OF WALK2UPGRADE4APP - CLOSE OUTPUT
        # -----------------------------------------------------------------------------------------            
        file2output.close()
        message2print = "{(Step 31B/33) closed" + "; file2output-closed-by-walk2upgrade4app: " + str(file2output) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # <_io.TextIOWrapper name='G://temp//job2studio4xi//out//one2ftp4app//app2ace4yo_app\\index.html' mode='w' encoding='cp1252'>
            
    else:
        message2print = "{(Step 1E/33) skipped" + "; path2input-skipped-by-walk2upgrade4app: " + str(path2input)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                      
        # 
            
        count2skipped = count2skipped + 1
        count2total = count2total + 1
                    
#</function4xi>
    

# =================================================================================================
#<class4xi class = "DirectoryWalker" base = "None" child = "None" synopsis = "a forward iterator that traverses a directory tree" usage = "
#   to review all tests"
#>
# =================================================================================================
class DirectoryWalker:

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init" usage = "initializes DirectoryWalker"> 
    # ---------------------------------------------------------------------------------------------
    def __init__(self, directory):
        self.stack = [directory]
        self.files = []
        self.index = 0
        
    #</methodize4xi>
            
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "getitem" usage = "getting item"> 
    # ---------------------------------------------------------------------------------------------
    def __getitem__(self, index):
        while 1:
            # ------------------------------------------------------------------------------------- 
            #
            # -------------------------------------------------------------------------------------          
            try:
                # --------------------------------------------------------------------------------- 
                #
                # ---------------------------------------------------------------------------------             
                file = self.files[self.index]
                self.index = self.index + 1
            except IndexError:
                # --------------------------------------------------------------------------------- 
                # pop next directory from stack
                # ---------------------------------------------------------------------------------             
                self.directory = self.stack.pop()
                self.files = os.listdir(self.directory)
                self.index = 0
            else:
                # --------------------------------------------------------------------------------- 
                # got a filename
                # ---------------------------------------------------------------------------------             
                fullname = os.path.join(self.directory, file)
                if os.path.isdir(fullname) and not os.path.islink(fullname):
                    self.stack.append(fullname)
                return fullname
    #</methodize4xi>
#</class4xi>

     
# -------------------------------------------------------------------------------------------------
#<function4xi function = "main" usage = "
#   reviewing all tests
#">                           
# -------------------------------------------------------------------------------------------------
def main():
    global ack2debug
    global count2skipped
    global count2replaced
    global count2total
    
    global path2read4xi
    global path2write4xi
    global profile2fetch

    global t2xi
    global trace_object_count    

       
                       
    # ------------------------------------------------------------------------------------------------- 
    # INITIALIZE
    # -------------------------------------------------------------------------------------------------        
    t2xi = Print4Xi()
    if ack2debug is True:
        print("(Step 0A/33) OF MAIN WALK2UPGRADE4APP - SET T2XI TO: ", t2xi)
        # <print4xi.Print4Xi object at 0x0000000003715080> 
    
     
    count2skipped = 0
    count2replaced = 0
    count2total  = 0   

    set2trace4replace()                                                                                               # trace all classes and functions in the system
    deny2trace4replace()                                                                                              # deny trace for all classes and functions in the system
    tailor2trace4xi()                                                                                               # tailor trace for this test    

    pipe2fetch = Pipe4Xi()
    queue2fetch = Queue4Xi()
    
    # --------------------------------------------------------------------------------------------- 
    # START
    # ---------------------------------------------------------------------------------------------        
    print('=' *70)
    print("(Step 0B/33) OF MAIN WALK2UPGRADE4APP - VERSION 4.4 FOR ", path2read4xi, " WITH PROFILE: ", profile2fetch, " STARTED ", time4xi())
    # VERSION 4.4 FOR  G://temp//job2studio4xi//in//one2do4app//  WITH PROFILE:  .html  STARTED  08:15:35 10/02/19 FLE Daylight Time
    
    pipe2fetch = Pipe4Xi()
    if ack2debug is True:
        print("(Step 1A/33) OF MAIN WALK2UPGRADE4APP - PIPE2FETCH ", pipe2fetch)    
        # PIPE2FETCH  (<pipeconnection4xi.PipeConnection4Xi object at 0x0000000002F71AC8>, <pipeconnection4xi.PipeConnection4Xi object at 0x0000000002F71B70>)
    queue2fetch = Queue4Xi()
    if ack2debug is True:
        print("(Step 1B/33) OF MAIN WALK2UPGRADE4APP - QUEUE2FETCH ", queue2fetch)    
        # QUEUE2FETCH  <queue4xi.Queue4Xi object at 0x0000000002F719B0>
        print("(Step 1C/33) OF MAIN WALK2UPGRADE4APP - PATH2READ4XI ", path2read4xi) 
        # PATH2READ4XI  G://temp//job2studio4xi//in//one2do4app//
        print("(Step 1D/33) OF MAIN WALK2UPGRADE4APP - PATH2WRITE4XI ", path2write4xi)
        # PATH2WRITE4XI  G://temp//job2studio4xi//out//one2ftp4app//
    
    for file2walk in DirectoryWalker(path2read4xi):
        # ----------------------------------------------------------------------------------------- 
        #
        # -----------------------------------------------------------------------------------------     
        if os.path.isdir(file2walk):
            print("(Step 2A/33) OF MAIN WALK2UPGRADE4APP - DIRECTORY: ", file2walk)
            # 
        if os.path.isfile(file2walk):
            walk2upgrade4app(file2walk)
            
    # --------------------------------------------------------------------------------------------- 
    # END
    # --------------------------------------------------------------------------------------------- 
    print('=' *75)
    print("(Step 3A/33) OF MAIN WALK2UPGRADE4APP - VERSION 4.4 - IN: ", path2read4xi, "- OUT: ", path2write4xi," - PROFILE: ", profile2fetch, " COMPLETED  ", time4xi())
    # IN:  G://temp//job2studio4xi//in//one2do4app// - 
    # OUT:  G://temp//job2studio4xi//out//one2ftp4app//  - 
    # PROFILE:  .html  
    # COMPLETED   08:15:35 10/02/19 FLE Daylight Time
            

       
    # ===========================================================================
    # print('=' *75)
    # print("(Step 4A/33) OF MAIN WALK2UPGRADE4APP - WALK2PARSE4APP CALLED FOR ", VersionKB4Xi['input2parse4app'])
    # G://temp//job2studio4xi//out//one2ftp4app//
    
    # path2read4xi = VersionKB4Xi['input2parse4app']
    # for file2walk in DirectoryWalker(path2read4xi):
        # ----------------------------------------------------------------------------------------- 
        #
        # -----------------------------------------------------------------------------------------     
    #     if os.path.isdir(file2walk):
    #         print("(Step 4B/33) OF MAIN WALK2UPGRADE4APP - PARSING DIRECTORY: ", file2walk)
            # G://temp//job2studio4xi//out//one2ftp4app//atlanticocean_app
            # G://temp//job2studio4xi//out//one2ftp4app//pacificocean_dev
            
    #     if os.path.isfile(file2walk):
    #         walk2parse4app(file2walk)
            
    
     
    # ---------------------------------------------------------------------------------------------    
    # Print Trace
    # ---------------------------------------------------------------------------------------------     
    # print ('(Step 1E/33) OF MAIN WALK2UPGRADE4APP - PRINTING TRACE WITH T2XI', t2xi)
    # 
    # print_trace4xi(t2xi)        
    # print ('(Step 1F/33) OF MAIN WALK2UPGRADE4APP - PRINTED TRACE WITH T2XI', t2xi)           
    
#</function4xi>
    
        
# -------------------------------------------------------------------------------------------------
if __name__ == '__main__':
    main()        
#</program4xi>


# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
# >> https://www.dragonxi.com/ 
# (Step 1C/33) OF MAIN WALK2UPGRADE4APP - PATH2READ4XI  G://temp//job2studio4xi//in//all2do4app//
# G://temp//job2studio4xi//in//all2do4app//aceit_app
# G://temp//job2studio4xi//in//all2do4app//aceit_dev
# G://temp//job2studio4xi//in//all2do4app//aeronautics_app
# G://temp//job2studio4xi//in//all2do4app//aeronautics_dev
# G://temp//job2studio4xi//in//all2do4app//angelfalls_app
# G://temp//job2studio4xi//in//all2do4app//angelfalls_dev
# G://temp//job2studio4xi//in//all2do4app//antarcticocean_app
# G://temp//job2studio4xi//in//all2do4app//antarcticocean_dev
# G://temp//job2studio4xi//in//all2do4app//app2ace4yo_app
# G://temp//job2studio4xi//in//all2do4app//arcticocean_app
# G://temp//job2studio4xi//in//all2do4app//arcticocean_dev
# G://temp//job2studio4xi//in//all2do4app//autonomousdevice_app
# G://temp//job2studio4xi//in//all2do4app//autonomousdevice_dev
# G://temp//job2studio4xi//in//all2do4app//autonomousrobot_app
# G://temp//job2studio4xi//in//all2do4app//autonomousrobot_dev
# G://temp//job2studio4xi//in//all2do4app//autonomoussystem_app
# G://temp//job2studio4xi//in//all2do4app//autonomoussystem_dev
# G://temp//job2studio4xi//in//all2do4app//autonomousvehicle_app
# G://temp//job2studio4xi//in//all2do4app//autonomousvehicle_dev
# G://temp//job2studio4xi//in//all2do4app//autovolante_app
# G://temp//job2studio4xi//in//all2do4app//bankholiday_app
# G://temp//job2studio4xi//in//all2do4app//bankholiday_dev
# G://temp//job2studio4xi//in//all2do4app//biomimicry_app
# G://temp//job2studio4xi//in//all2do4app//biomimicry_dev
# G://temp//job2studio4xi//in//all2do4app//chamberednautilus_app
# G://temp//job2studio4xi//in//all2do4app//chamberednautilus_dev
# G://temp//job2studio4xi//in//all2do4app//convolutionalneuralnetwork_app
# G://temp//job2studio4xi//in//all2do4app//convolutionalneuralnetwork_dev
# G://temp//job2studio4xi//in//all2do4app//cryogenics_app
# G://temp//job2studio4xi//in//all2do4app//cryogenics_dev
# G://temp//job2studio4xi//in//all2do4app//deeplearninginference_app
# G://temp//job2studio4xi//in//all2do4app//deeplearninginference_dev
# G://temp//job2studio4xi//in//all2do4app//dragonxi_app
# G://temp//job2studio4xi//in//all2do4app//dragonxi_dev
# G://temp//job2studio4xi//in//all2do4app//elastronics_app
# G://temp//job2studio4xi//in//all2do4app//elastronics_dev
# G://temp//job2studio4xi//in//all2do4app//encrypted_dragonxi
# G://temp//job2studio4xi//in//all2do4app//energylevel_app
# G://temp//job2studio4xi//in//all2do4app//energylevel_dev
# G://temp//job2studio4xi//in//all2do4app//flugauto_app
# G://temp//job2studio4xi//in//all2do4app//gimbal
# G://temp//job2studio4xi//in//all2do4app//halongbay_app
# G://temp//job2studio4xi//in//all2do4app//halongbay_dev
# G://temp//job2studio4xi//in//all2do4app//indianocean_app
# G://temp//job2studio4xi//in//all2do4app//jee_app
# G://temp//job2studio4xi//in//all2do4app//juhannus_app
# G://temp//job2studio4xi//in//all2do4app//juhannus_dev
# G://temp//job2studio4xi//in//all2do4app//knowledgereasoning_app
# G://temp//job2studio4xi//in//all2do4app//lexicology_app
# G://temp//job2studio4xi//in//all2do4app//lexicology_dev
# G://temp//job2studio4xi//in//all2do4app//lidarsystem_app
# G://temp//job2studio4xi//in//all2do4app//lidarsystem_dev
# G://temp//job2studio4xi//in//all2do4app//limnology_app
# G://temp//job2studio4xi//in//all2do4app//limnology_dev
# G://temp//job2studio4xi//in//all2do4app//longrangehunting_app
# G://temp//job2studio4xi//in//all2do4app//longrangehunting_dev
# G://temp//job2studio4xi//in//all2do4app//marlinfishing_app
# G://temp//job2studio4xi//in//all2do4app//marlinfishing_dev
# G://temp//job2studio4xi//in//all2do4app//midsummer_app
# G://temp//job2studio4xi//in//all2do4app//midsummer_dev
# G://temp//job2studio4xi//in//all2do4app//missionprofile_app
# G://temp//job2studio4xi//in//all2do4app//motovolante_app
# G://temp//job2studio4xi//in//all2do4app//namib_app
# G://temp//job2studio4xi//in//all2do4app//namib_dev
# G://temp//job2studio4xi//in//all2do4app//objectdetection_app
# G://temp//job2studio4xi//in//all2do4app//objectdetection_dev
# G://temp//job2studio4xi//in//all2do4app//oceanography_app
# G://temp//job2studio4xi//in//all2do4app//oceanography_dev
# G://temp//job2studio4xi//in//all2do4app//personal_robot_app
# G://temp//job2studio4xi//in//all2do4app//personal_robot_dev
# G://temp//job2studio4xi//in//all2do4app//polarcircle_app
# G://temp//job2studio4xi//in//all2do4app//polarnight_app
# G://temp//job2studio4xi//in//all2do4app//qlearning_app
# G://temp//job2studio4xi//in//all2do4app//qlearning_dev
# G://temp//job2studio4xi//in//all2do4app//reasonit_app
# G://temp//job2studio4xi//in//all2do4app//reasonit_dev
# G://temp//job2studio4xi//in//all2do4app//rubalkhali_app
# G://temp//job2studio4xi//in//all2do4app//rubalkhali_dev
# G://temp//job2studio4xi//in//all2do4app//senseit_app
# G://temp//job2studio4xi//in//all2do4app//senseit_dev
# G://temp//job2studio4xi//in//all2do4app//situate_app
# G://temp//job2studio4xi//in//all2do4app//situate_dev
# G://temp//job2studio4xi//in//all2do4app//smartban_app
# G://temp//job2studio4xi//in//all2do4app//smartban_dev
# G://temp//job2studio4xi//in//all2do4app//southernocean_app
# G://temp//job2studio4xi//in//all2do4app//southernocean_dev
# G://temp//job2studio4xi//in//all2do4app//spacescience_app
# G://temp//job2studio4xi//in//all2do4app//spacescience_dev
# G://temp//job2studio4xi//in//all2do4app//taxivolant_app
# G://temp//job2studio4xi//in//all2do4app//tepui_app
# G://temp//job2studio4xi//in//all2do4app//tepui_dev
# G://temp//job2studio4xi//in//all2do4app//thirdpole_app
# G://temp//job2studio4xi//in//all2do4app//thirdpole_dev
# G://temp//job2studio4xi//in//all2do4app//transferlearning_app
# G://temp//job2studio4xi//in//all2do4app//transferlearning_dev
# G://temp//job2studio4xi//in//all2do4app//unmannedsystem_app
# G://temp//job2studio4xi//in//all2do4app//unmannedsystem_dev
# G://temp//job2studio4xi//in//all2do4app//visionvolante_app
# G://temp//job2studio4xi//in//all2do4app//visionvolante_dev
# G://temp//job2studio4xi//in//all2do4app//volans_app
# G://temp//job2studio4xi//in//all2do4app//waterexploration_app
# G://temp//job2studio4xi//in//all2do4app//xenobiotic_app
# G://temp//job2studio4xi//in//all2do4app//xenobiotic_dev
# G://temp//job2studio4xi//in//all2do4app//yocto_app
# G://temp//job2studio4xi//in//all2do4app//yodragonxicom
# G://temp//job2studio4xi//in//all2do4app//yodragonxiorg
# G://temp//job2studio4xi//in//all2do4app//zeroshotlearning_app
# G://temp//job2studio4xi//in//all2do4app//zeroshotlearning_dev
# (Step 1D/33) OF MAIN WALK2UPGRADE4APP - PATH2WRITE4XI  G://temp//job2studio4xi//out//all2ftp4app//
#"
#>
#     
# 
# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 
#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of walk2upgrade4app.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>

